module Data.Functor.Extension.Kan (Ran (..), Lan (..)) where

import "morphisms" Control.Morphism ((.), ($))

import Control.Functor.Contravariant (Contravariant ((>$<)))
import Control.Functor.Covariant (Covariant ((<$>)))

newtype Ran (t :: * -> *) (u :: * -> *) (b :: *) (a :: *) =
	Ran { ran :: (a -> t b) -> u b }

instance Covariant (Ran t u b) where
	f <$> Ran x = Ran $ x . (. f)

newtype Lan (t :: * -> *) (u :: * -> *) (b :: *) (a :: *) =
	Lan { lan :: (t b -> a) -> u b }

instance Contravariant (Lan t u b) where
	f >$< Lan x = Lan $ x . (f .)
